routes/admin.php
<?php

use App\Http\Controllers\AdminControllers\AuthController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AdminControllers\DashboardController;


Route::get('/login', [AuthController::class, 'login_page'])->name('admin.login_page');
Route::post('/login', [AuthController::class, 'login'])->name('admin.login');




/*All Admin Routes List*/
Route::middleware(['auth', 'user-access:admin'])->namespace('App\Http\Controllers\AdminControllers')->group(function () {
    Route::get('/dashboard', [DashboardController::class, 'dashboard'])->name('admin.dashboard');

    //students
    Route::resource('students', 'StudentController');
    //teachers
    Route::resource('teachers', 'TeacherController');
    //extensions
    Route::resource('extensions', 'ExtensionController');
    //levels
    Route::resource('levels', 'LevelController');
    //categories
    Route::resource('categories', 'CategoryController');
    //skills
    Route::resource('skills', 'SkillController');
    //courses
    Route::resource('courses', 'CourseController');

    //curriculums
    Route::resource('curriculums', 'CurriculumController');

    //scheduled
    Route::resource('scheduleds', 'ScheduledController');

    //units
    Route::resource('units', 'UnitController');

    //lessons
    Route::resource('lessons', 'LessonController');

    Route::get('moduleFile/destroy/{id}', [\App\Http\Controllers\AdminControllers\CurriculumController::class,'moduleFileDestroy'])->name('moduleFile.destroy');


    //Sprint 3
    //calendars
    Route::resource('calendars', 'CalendarController');
    //calendar Questions
    Route::resource('calendar_questions', 'CalendarQuestionController');
    //calendar answers
    Route::resource('calendar_answers', 'CalendarAnswerController');



});

routes/web.php
<?php

use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\WebsiteControllers\CalendarController;
use App\Http\Controllers\WebsiteControllers\CourseController;
use App\Http\Controllers\WebsiteControllers\CurriculumController;
use App\Http\Controllers\WebsiteControllers\LessonController;
use App\Http\Controllers\WebsiteControllers\ScheduledController;
use App\Http\Controllers\WebsiteControllers\UnitController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\WebsiteControllers\HomePageController;
use App\Http\Controllers\WebsiteControllers\TeacherController;
use App\Http\Controllers\WebsiteControllers\SkillController;
use App\Http\Controllers\WebsiteControllers\CategoryController;
use App\Http\Controllers\StudentControllers\AuthController;
use App\Http\Controllers\StudentControllers\DashboardController;


//Auth::routes();
Route::get('/student/register', [AuthController::class, 'register_page'])->name('website.student.register_page');
Route::post('/student/register', [AuthController::class, 'register'])->name('website.student.register');
Route::get('/student/login', [AuthController::class, 'login_page'])->name('website.student.login_page');
Route::post('/student/login', [AuthController::class, 'login'])->name('website.student.login');
Route::post('/logout', [LoginController::class, 'logout'])->name('logout');
Route::get('/forget_password', [AuthController::class, 'forget_password'])->name('website.forget_password');
Route::post('/reset_password', [AuthController::class, 'reset_password'])->name('website.reset_password');
Route::get('/reset_password/{token}', [AuthController::class, 'change_reset_password'])->name('website.change_reset_password');
Route::post('/change_reset_password', [AuthController::class, 'change_reset_password_post'])->name('website.change_reset_password');
Route::get('/verification_email/{encryptID}', [AuthController::class, 'verification_email'])->name('website.verification_email');

Route::get('/', [HomePageController::class, 'index'])->name('website.index');

Route::middleware('auth')->group(function(){
    Route::get('/teachers', [TeacherController::class, 'index'])->name('website.teachers.index');
    Route::get('/teacher/{id}', [TeacherController::class, 'show'])->name('website.teachers.show');
    Route::get('/skills', [SkillController::class, 'index'])->name('website.skills.index');
    Route::get('/skill/{id}', [SkillController::class, 'show'])->name('website.skills.show');
    Route::get('/categories', [CategoryController::class, 'index'])->name('website.categories.index');
    Route::get('/category/{id}', [CategoryController::class, 'show'])->name('website.categories.show');
    Route::get('/courses', [CourseController::class, 'index'])->name('website.courses.index');
    Route::get('/course/{id}', [CourseController::class, 'show'])->name('website.courses.show');
    Route::get('/curriculums', [CurriculumController::class, 'index'])->name('website.curriculums.index');
    Route::get('/curriculum/{id}', [CurriculumController::class, 'show'])->name('website.curriculums.show');
    Route::get('/scheduled/{id}', [ScheduledController::class, 'show'])->name('website.scheduleds.show');
    Route::get('/unit/{id}', [UnitController::class, 'show'])->name('website.units.show');
    Route::get('/lesson/{id}', [LessonController::class, 'show'])->name('website.lessons.show');

    Route::post('/student_upload_course_file_answers/{id}', [CourseController::class, 'studentUploadCourseFileAnswers'])->name('website.courses.studentUploadCourseFileAnswers');
    Route::get('/student_delete_course_file_answers/{id}', [CourseController::class, 'studentDeleteCourseFileAnswers'])->name('website.courses.deleteUserFile');

    Route::post('/student_ask_question_course/{id}', [CourseController::class, 'studentAskQuestion'])->name('website.courses.studentAskQuestion');
    Route::get('/student_delete_question_course/{id}', [CourseController::class, 'studentDeleteCourseQuestion'])->name('website.courses.deleteUserQuestion');

    Route::get('/myFavorite/{id}', [CourseController::class, 'addToFavorite'])->name('website.courses.addToFavorite');
    Route::get('/myFavorite', [CourseController::class, 'myFavorite'])->name('website.courses.myFavorite');
    Route::get('/removeFromFavorite/{id}', [CourseController::class, 'removeFromFavorite'])->name('website.courses.removeFromFavorite');
    Route::post('/rating/{id}', [CourseController::class, 'rating'])->name('website.courses.rating');



    //Calendars Routes
    Route::get('/calendar/show/{id}', [CalendarController::class, 'show'])->name('website.calendars.show');
    Route::get('/calendar/go_exam/{id}', [CalendarController::class, 'go_exam'])->name('website.calendars.go');
    Route::post('/calendar/save_exam/{id}', [CalendarController::class, 'save_exam'])->name('website.calendar.save_exam');
    Route::get('/calendar/finished_exam/thanks', [CalendarController::class, 'thanks_after_finished'])->name('website.calendars.thanks');




});



/*All Normal Students Routes List*/
Route::middleware(['auth', 'user-access:student'])->group(function () {
    Route::get('/student/dashboard', [DashboardController::class, 'dashboard'])->name('website.student.dashboard');
    Route::post('/student/update', [DashboardController::class, 'update'])->name('website.student.update');

    Route::get('/student/calendars', [DashboardController::class, 'myCalendars'])->name('website.student.calendars');

});

app/Http/Controllers/AdminControllers/TeacherController.php
<?php

namespace App\Http\Controllers\AdminControllers;

use App\Http\Controllers\Controller;
use App\Http\Requests\StudentRequest;
use App\Http\Traits\HelperTrait;
use App\Models\User;
use App\Models\UserInfo;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;

class TeacherController extends Controller
{
    use HelperTrait;

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $content = User::with('userInfo')->whereType(2)->orderBy('id', 'asc')->paginate($this->paginate);
        return view('admin_dashboard.teachers.index' , compact('content'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('admin_dashboard.teachers.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StudentRequest $request)
    {
        $data = $request->validated();
        DB::beginTransaction();
        try {
            $created = User::create([
                'type' =>2,
                'name' =>$data['name'],
                'email' =>$data['email'],
                'email_verified_at' =>date('Y-m-d H:i:s'),
                'second_email' =>$data['second_email'],
                'password' =>Hash::make($data['password']),
            ]);
            $this->createUserInfo($data,$created->id,$request, $type='created');
            DB::commit();
            toastr()->success($this->insertMsg, 'نجح', ['timeOut' => 5000]);
            return redirect()->back();
        } catch (\Exception $e) {
            DB::rollback();
            toastr()->error($this->error, 'فشل', ['timeOut' => 5000]);
            return redirect()->back();
        }

    }


    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        $content =  User::with('userInfo')->whereType(2)->findOrFail($id);
        return view('admin_dashboard.teachers.edit', compact('content'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(StudentRequest $request, $id)
    {
        $user =  User::with('userInfo')->whereType(2)->findOrFail($id);

        $data = $request->validated();

        DB::beginTransaction();
        try {
            $user->update([
                'name' =>$data['name'],
                'email' =>$data['email'],
                'second_email' =>$data['second_email'],
                'email_verified_at' =>isset($data['email_verified_at']) ? date('Y-m-d H:i:s') : NULL,
            ]);
            $this->createUserInfo($data,$user->id,$request, $type='updated');

            DB::commit();
            toastr()->success($this->updateMsg, 'نجح', ['timeOut' => 5000]);
            return redirect()->back();
        } catch (\Exception $e) {
            DB::rollback();
            toastr()->error($this->error, 'فشل', ['timeOut' => 5000]);
            return redirect()->back();
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        $content =  User::whereType(2)->findOrFail($id);

        $content->userInfo->delete();
        $content->courses->delete();
        $content->delete();
        toastr()->success($this->deleteMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }



}

app/Http/Controllers/WebsiteControllers/TeacherController.php
<?php

namespace App\Http\Controllers\WebsiteControllers;

use App\Http\Controllers\Controller;
use App\Models\Course;
use App\Models\User;
use Illuminate\Http\Request;

class TeacherController extends Controller
{
    //Index
    public function index()
    {
        $page_title = ' المحاضرين';
        $content = User::with(['userInfo','courses'])->whereType(2)->whereNotNull('email_verified_at')->paginate(config('app.paginate'));
        return view('website.teachers',compact('content','page_title'));
    }

    //show
    public function show($id)
    {
        $content = User::with(['userInfo','courses'])->whereType(2)->whereNotNull('email_verified_at')->whereId($id)->first();
        if(!$content || $content->userInfo?->status == 'no')
        {
            return view('errors.404');
        }

        $page_title = $content->name;
        return view('website.single-teacher',compact('content','page_title'));
    }

}

resources/views/admin_dashboard/teachers/create.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')    المعلمين | إضافة   @endsection


@section('content')

    <div class="row">
        <div class="col-lg-12 mx-auto">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex align-items-center">
                        <h5 class="mb-0"> <i class="bi bi-grid-fill"></i>   المعلمين  | اضافة عنصر جديد </h5>
                    </div>
                    <div class="row g-3 mt-4">
                        <div class="col-12">
                            <div class="card shadow-none bg-light border">
                                <div class="card-body">
                                    <form class="row g-3" id="validateForm" method="post" enctype="multipart/form-data"
                                    action="{{route('teachers.store')}}">
                                        @csrf

                                        <div class="col-md-6">
                                            <label class="form-label"> الأسم <span class="text-danger">*</span> </label>
                                            <input type="text" id="name" name="name" class="form-control" required />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> البريد الالكتروني <span class="text-danger">*</span> </label>
                                            <input type="email" id="email" name="email" class="form-control" required />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label">  رقم الهاتف <span class="text-danger">*</span> </label>
                                            <input type="number" min="0" id="phone" name="phone" class="form-control" required />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> البريد الالكتروني البديل </label>
                                            <input type="email" id="second_email" name="second_email" class="form-control"  />
                                        </div>

                                        <div class="col-md-12">
                                            <label class="form-label">المجموعة<span class="text-danger">*</span> </label>
                                            <select class="form-control" name="group_type" required>
                                                <option value=""> اختر نوع المجموعة </option>
                                                <option value="d"> مجموعة ضابطة </option>
                                                <option value="t"> مجموعة تجريبية </option>
                                            </select>
                                        </div>

                                        <div class="col-md-6">
                                            <label class="form-label">النوع </label>
                                            <select class="form-control" name="gender">
                                                <option value="male"> ذكر </option>
                                                <option value="female"> أنثي </option>
                                            </select>
                                        </div>

                                        <div class="col-md-6">
                                            <label class="form-label"> المسمي الوظيفي   </label>
                                            <input type="text" id="job_title" name="job_title" class="form-control"  />
                                        </div>


                                        <div class="col-md-6">
                                            <label class="form-label"> الرقم القومي  </label>
                                            <input type="text" id="national_id" name="national_id" class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> المدينة  </label>
                                            <input type="text" id="city" name="city" class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> التخصص  </label>
                                            <input type="text" id="specialist" name="specialist" class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> المؤهل الدراسي  </label>
                                            <input type="text" id="qualification" name="qualification" class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> المدرسة أو الكلية أو المعهد  </label>
                                            <input type="text" id="school_or_college" name="school_or_college" class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label"> الادارة / القسم  </label>
                                            <input type="text" id="department" name="department" class="form-control"  />
                                        </div>

                                        <div class="col-12">
                                            <label class="form-label"> الصوره  <small class="text-danger">(PNG - JPEG - JPG - WEBP - SVG - GIF)</small> </label>
                                            <input class="form-control" type="file" name="image" accept="image.*" >
                                        </div>

                                        <div class="col-12">
                                            <label class="form-label">   سبب التقدم</label>
                                            <textarea name="reason" class="form-control"
                                                       rows="4" cols="4"></textarea>
                                        </div>


                                        <div class="col-md-6">
                                            <label class="form-label">  كلمة المرور <span class="text-danger">*</span>  </label>
                                            <input type="password" id="password" name="password" required class="form-control"  />
                                        </div>
                                        <div class="col-md-6">
                                            <label class="form-label">  تأكيد كلمة المرور  <span class="text-danger">*</span> </label>
                                            <input type="password" id="password_confirmation" name="password_confirmation" required class="form-control"  />
                                        </div>


                                        <div class="col-12 mt-3">
                                            <label class="form-check-label" for="flexSwitchCheckChecked">تنشيط الحساب</label>
                                            <div class="form-check form-switch mt-2">
                                                <input class="form-check-input customSliderCheckbox" type="checkbox"
                                                       name="status" value="yes" id="flexSwitchCheckChecked" checked="">
                                            </div>
                                        </div>



                                        @include('admin_dashboard.inputs.add_btn')
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div><!--end row-->
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.5/jquery.validate.min.js" integrity="sha512-rstIgDs0xPgmG6RX1Aba4KV5cWJbAMcvRCVmglpam9SoHZiUCyQVDdH2LPlxoHtrv17XWblE/V/PP+Tr04hbtA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function () {
        $("#validateForm").validate({
            rules: {
                name: {
                    required: true,
                },
                email: {
                    required: true,
                },
                phone: {
                    required: true,
                },
                group_type: {
                    required: true,
                },
                password: {
                    required: true,
                },
                password_confirmation: {
                    required: true,
                    equalTo:'#password'
                },

            },
            messages: {
                name: {
                    required: "الحقل مطلوب",
                },
                email: {
                    required: "الحقل مطلوب",
                },
                phone: {
                    required: "الحقل مطلوب",
                },
                group_type: {
                    required: "الحقل مطلوب",
                },
                password: {
                    required: "الحقل مطلوب",
                },
                password_confirmation: {
                    required: "الحقل مطلوب",
                    equalTo: " كلمة المرور غير متطابقة",
                },

            }
        });
    });
</script>

    <script>
        $(document).ready(function() {
            if (window.File && window.FileList && window.FileReader) {
                $("#files").on("change", function(e) {
                    var files = e.target.files,
                        filesLength = files.length;
                    for (var i = 0; i < filesLength; i++) {
                        var f = files[i]
                        var fileReader = new FileReader();
                        fileReader.onload = (function(e) {
                            var file = e.target;
                            $("<span class=\"pip\">" +
                                "<img class=\"imageThumb\" src=\"" + e.target.result + "\" title=\"" + file.name + "\"/>" +
                                "<br/><span class=\"remove\"><i class='bx bx-trash-alt'></i></span>" +
                                "</span>").insertAfter("#files");
                            $(".remove").click(function(){
                                $(this).parent(".pip").remove();
                            });

                        });
                        fileReader.readAsDataURL(f);
                    }
                    console.log(files);
                });
            } else {

            }
        });
    </script>
@endpush

resources/views/admin_dashboard/teachers/index.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')  المعلمين  @endsection

@section('content')


    <div class="card">
        <div class="card-body">
            <div class="d-flex align-items-center">
                <h5 class="mb-0"> <i class="lni lni-consulting"></i> المعلمين</h5>
                <div class="ms-auto position-relative">
                    <a href="{{route('teachers.create')}}" class="btnIcon btn btn-outline-primary px-5"><i class="lni lni-circle-plus"></i> أضف عنصر جديد </a>
                </div>
            </div>
            <div class="table-responsive mt-4">
                <table class="table align-middle">
                    <thead class="table-secondary">
                    <tr>
                        <th>#</th>
                        <th>الأسم</th>
                        <th>المجموعه</th>
                        <th>البريد الالكتروني</th>
                        <th> التحقق من الحساب </th>
                        <th> تنشيط الحساب </th>
                        <th>التحكم</th>
                    </tr>
                    </thead>
                    <tbody>
                        @forelse($content as $con)
                        <tr>
                            <td>{{$con->id}}</td>

                            <td>{{$con->name}}</td>
                            <td><span class="badge @if($con->userInfo?->group_type == 'd') bg-light-success text-success @else bg-light-warning text-warning @endif w-50">
                                    {{ $con->userInfo?->group_type == 'd' ? 'مجموعة ضابطة' : ' مجموعة تجريبية' }}</span></td>
                            <td>{{$con->email}}</td>
                            <td><span class="badge @if($con->email_verified_at) bg-light-success text-success @else bg-light-danger text-danger @endif w-50">
                                    {{$con->email_verified_at ? ' مفعل ' : ' غير مفعل' }}</span></td>

                            <td><span class="badge @if($con->userInfo?->status == 'yes') bg-light-success text-success @else bg-light-danger text-danger @endif w-50">
                                    {{$con->userInfo?->status == 'yes' ? ' نشط ' : ' غير نشط' }}</span></td>
                            <td>
                                <div class="table-actions d-flex align-items-center gap-3 fs-6">
                                    <a href="{{route('teachers.edit', $con->id)}}" class="text-warning" data-bs-toggle="tooltip" data-bs-placement="bottom"
                                       title="تعديل"><i class="bi bi-pencil-fill"></i></a>
                                    <a href="javascript:;"  data-bs-toggle="modal" data-bs-target="#deleteItem{{$con->id}}" class="text-danger" data-bs-toggle="tooltip"
                                       data-bs-placement="bottom" title="حذف"><i class="bi bi-trash-fill"></i></a>
                                    <div class="modal fade" id="deleteItem{{$con->id}}" tabindex="-1" aria-labelledby="link{{$con->id}}" aria-hidden="true">
                                        <div class="modal-dialog modal-dialog-centered">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="link{{$con->id}}">هل أنت متأكد من حذف هذا العنصر ؟</h5>
                                                    <button class="btn-close" type="button" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-footer">
                                                    <button class="btn btn-outline-default btn-sm me-2" type="button" data-bs-dismiss="modal">لا</button>
                                                    <form action="{{route('teachers.destroy',$con->id)}}" method="POST">
                                                        @method('DELETE')
                                                        @csrf
                                                        <button type="submit" class="btn btn-outline-danger btn-sm" type="button">نعم</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                            </td>
                        </tr>
                        @empty
                            <tr>
                                <td colspan="6" class="text-center">
                                    <p> لا يوجد بيانات </p>
                                </td>
                            </tr>
                        @endforelse
                    </tbody>
                </table>
                <div>
                    {{$content->links()}}
                </div>
            </div>
        </div>
    </div>


@endsection